{$APPTYPE CONSOLE}
var
  f: TextFile;
  z: Boolean;
  h, v, x1, y1, x2, y2, dx, dy: Int64;

  function Cross(xa, ya, xb, yb: Int64): Boolean;
  var
    s1, s2: Int64;
  begin
    s1 := (xa - x1) * dy - (ya - y1) * dx;
    s2 := (xb - x1) * dy - (yb - y1) * dx;
    z := (s1 = 0) or (s2 = 0);
    Result := z or ((s1 > 0) xor (s2 > 0));
  end;

  function Check(dn: Int64): Boolean;
  var
    x, y, px, py: Int64;
    m: Integer;
  begin
    m := dn and 1;
    x := h * ((dn - m) div 2 + 1);
    y := v * ((dn + m) div 2);
    px := x; py := y;
    if m = 0 then Dec(px, h) else Dec(py, v);
    Result := Cross(x, y, px, py);
  end;
  
  function CrossPt(xa, ya, xb, yb: Int64): Int64;
  var
    d: Int64;
  begin
    d := dx * (yb - ya) - dy * (xb - xa);
    //Writeln((dx * (y1 - ya) - dy * (x1 - xa)) / d:0:10);
    Result := ((dx * (y1 - ya) - dy * (x1 - xa)) div d) * 2;
  end;
  
  function Solve: Int64;
  const
    R = 10;
  var
    i, n1, n2: Int64;
  begin
    if x1 = x2 then begin
      if x1 mod h = 0 then Result := -1 else Result := 1;
      exit;
    end;
    if y1 = y2 then begin
      if y1 mod v = 0 then Result := -1 else Result := 1;
      exit;
    end;
    dx := x2 - x1; dy := y2 - y1;
    Result := 0;
    if dx * v = h * dy then begin
      if Cross(0, 0, h, 0) then
        Result := -1;
      exit;
    end;
    n1 := CrossPt(0, -v, h, 0);
    n2 := CrossPt(0, 0, h, v);
    if n1 > n2 then begin i := n1; n1 := n2; n2 := i; end;
    i := n1 + R; Dec(n1, R);
    Assert(not Check(n1));
    while (n1 <= i) and not Check(n1) do Inc(n1);
    if z then Inc(n1);
    Assert(Check(n1));

    i := n2 - R; Inc(n2, R);
    Assert(not Check(n2));
    while (n2 >= i) and not Check(n2) do Dec(n2);
    if z and (n2 > n1) then Dec(n2);
    Assert(Check(n2));
    //Writeln('==> ', n1, ' ', n2);
    Result := n2 - n1 + 1;
  end;

begin
  AssignFile(f, 'input.txt'); Reset(f);
  Read(f, h, v, x1, y1, x2, y2);
  CloseFile(f);
  AssignFile(f, 'output.txt'); Rewrite(f);
  Writeln(f, Solve);
  CloseFile(f);
end.